#line 1 "C:/Users/Fellow/Desktop/LCD_Gen_Config/Frequency_counter_4MHz_LCD_TMR1.c"
#line 1 "c:/users/fellow/desktop/lcd_gen_config/bit.h"
#line 1 "c:/users/fellow/desktop/lcd_gen_config/delay.h"
#line 23 "c:/users/fellow/desktop/lcd_gen_config/delay.h"
void delay_10_us(void) ;
void delay_100_us(void);
void delay_500_us(void);
#line 1 "c:/users/fellow/desktop/lcd_gen_config/bcd.h"
#line 15 "c:/users/fellow/desktop/lcd_gen_config/bcd.h"
void ulong2str(long lng, char *op);
void ulong2bcd(unsigned long num);

void ulong2bcd_p1(unsigned long num);
void ulong2bcd_process(void);
void process_ulong2str(char *str);

void strrev(char *s);
void test_asm(void);
#line 38 "C:/Users/Fellow/Desktop/LCD_Gen_Config/Frequency_counter_4MHz_LCD_TMR1.c"
unsigned long ldmy=0;
unsigned short sdmy=0;



void init_ports(void) {
 ADCON1 = 0x06;
 PORTD = 0;
 TRISD = 0;
 TRISC = 0x81;
}
#line 66 "C:/Users/Fellow/Desktop/LCD_Gen_Config/Frequency_counter_4MHz_LCD_TMR1.c"
unsigned long gate_loop(unsigned int gt) org 200 {
unsigned long oc = 0;

 do {
 gt--;


 sdmy = PIR1 & (1<<TMR1IF);
 asm {
 CLRW ;
 }

 if (sdmy!=0) {
 PIR1 &= ~(1<<TMR1IF);
 oc += 1;
 } else {
 sdmy &= ~(1<<TMR1IF);
 ldmy += 1;
 asm {
 CLRW ;
 }
 }
 delay_500_us();
 delay_100_us();
 delay_100_us();
 delay_100_us();
 delay_100_us();
 delay_10_us();
 delay_10_us();
 delay_10_us();
 delay_10_us();
 delay_10_us();
 asm {
 CLRW
 CLRW
 CLRW
 }
 } while (gt>0);

 return oc;
}



void main() org 400 {
char op[12] ;
unsigned short st_TMR1L ;
unsigned short st_TMR1H ;
unsigned long st_TMR1_ovfl=0 ;
unsigned long df = 0 ;
unsigned short blinkc=0 ;
char lcdop[4];

 init_ports();


 T1CON = (1<<TMR1ON) | (1<<TMR1CS) | (1<<T1SYNC);


 PIE1 = (1<<TMR1IE) ;


 Lcd_Config(&PORTD,1,0,2,7,6,5,4);
 LCD_Cmd(LCD_CLEAR);
 LCD_Cmd(LCD_CURSOR_OFF);
 LCD_Out(1,4,"WELCOME TO");
 LCD_Out(2,3,"FREQ. COUNTER");
 delay_ms(2000);
 LCD_Cmd(LCD_CLEAR);


 for(;;) {
 if (blinkc>0) {
 PORTC=0xff;
 } else {
 PORTC=0x00;
 }
 blinkc=~blinkc;


 if (!(st_TMR1L==0 && st_TMR1H==0 && st_TMR1_ovfl==0) ) {
 df = st_TMR1L+(st_TMR1H<<8)+(st_TMR1_ovfl<<16);
 } else {
 df = 0;
 }

 ulong2bcd(df);
 process_ulong2str(op);

 LCD_Out(1,1,"f(input\)");
 LCD_Cmd(LCD_SECOND_ROW);
 Lcd_Cmd(LCD_RETURN_HOME);
 LCD_Out(2,1,op);


 st_TMR1L = 0;
 st_TMR1H = 0;
 st_TMR1_ovfl = 0;

 TMR1H = 0;
 PIR1 &= ~(1<<TMR1IF);
 TMR1L = 0;








 st_TMR1_ovfl = gate_loop(1000);

 delay_500_us();
 delay_100_us();
 delay_100_us();
 delay_10_us();
 asm {
 CLRW
 CLRW
 CLRW
 CLRW
 }


 st_TMR1L = TMR1L;
 st_TMR1H = TMR1H;

 LCD_Out_Cp(" Hz");



 if ( PIR1 & (1<<TMR1IF) ) {
 PIR1 &= ~(1<<TMR1IF);
 st_TMR1_ovfl += 1;
 }
 }
}
