#line 1 "C:/Users/Fellow/Desktop/LCD_Gen_Config/bcd.c"
#line 77 "C:/Users/Fellow/Desktop/LCD_Gen_Config/bcd.c"
static char DIG absolute 0x30;
static char DIG1 absolute 0x31;
static char DIG2 absolute 0x32;
static char DIG3 absolute 0x33;
static char DIG4 absolute 0x34;
static char DIG5 absolute 0x35;
static char DIG6 absolute 0x36;
static char DIG7 absolute 0x37;
static char DIG8 absolute 0x38;
static char DIG9 absolute 0x39;


static unsigned short BITCNT absolute 0x3A;
static unsigned short DIGCNT absolute 0x3B;


static unsigned short BIN3 absolute 0x2C;
static unsigned short BIN2 absolute 0x2E;
static unsigned short BIN1 absolute 0x2D;
static unsigned short BIN0 absolute 0x2F;









void ulong2bcd_p1(unsigned long num) {

unsigned short *p;
p = (unsigned short) &num;



bin0 = *(p++); bin1 = *(p++);
bin2 = *(p++); bin3 = *(p++);

dig = 0; dig1 = 0; dig2 = 0;
dig3 = 0; dig4 = 0; dig5 = 0;
dig6 = 0; dig7 = 0; dig8 = 0; dig9 = 0;

DIGCNT = 0;
BITCNT = 16;


asm {

BITLOOP:
 movlw 10
 movwf bcd_DIGCNT
 movlw bcd_DIG
 movwf FSR


 rlf bcd_BIN0,F
 rlf bcd_BIN1,F
 rlf bcd_BIN2,F
 rlf bcd_BIN3,F

PROCESSDIGITSLOOP:
 rlf INDF,F
 movlw -10
 addwf INDF,W
 btfsc STATUS,C
 addlw 6
 addlw 10
 movwf INDF

 BCF STATUS,C
 btfsc INDF,4
 BSF STATUS,C

 andlw 0x0f
 movwf INDF

 INCF FSR,F

 decfsz bcd_DIGCNT,F
 goto PROCESSDIGITSLOOP

 decfsz bcd_BITCNT,F
 goto BITLOOP

}

}
#line 176 "C:/Users/Fellow/Desktop/LCD_Gen_Config/bcd.c"
void ulong2bcd_process(void) {

BITCNT = 16;

 asm {
 call BITLOOP
 }
}





void ulong2bcd(unsigned long num) {
unsigned short i;

 ulong2bcd_p1(num);


 ulong2bcd_process(void);

}


void packedBCDToStr(unsigned short packedBCD,unsigned short len, char *op) {
unsigned short *p=packedBCD, val, i;

 for (i=0;i<len;i++) {
 val = (*p >> 4) + '0';
 *(op++) = val;
 val = (*p & 0x0f) + '0';
 *(op++) = val;
 p++;
 }
}


void unpackedBCDtoStr(unsigned short *bcd, unsigned short c, char *op) {
unsigned short i;

 for(i=0;i<c;i++) {
 *(op++) = (*(bcd++)) + '0';
 }
 *op=0;
}






void strrev(char *s) {
unsigned short i,len;
char *e, *p, st;

 len = strlen(s);
 e = s+len-1;

 for ( i=0; i<(len>>1); i++) {
 st = *e;
 *e=*s;
 *s = st;
 e--;
 s++;
 }
}








void process_ulong2str(char *str) {

char *s=str;
unsigned short stop=0;


 unpackedBCDtoStr(&DIG, 10, str);


 strrev(str);
 s = str;
 while (*s) {
 if (*s!='0') { stop=1; }
 if (!stop) {
 if (*s=='0') {*s=' '; }
 }
 s++;
 }
}



void ulong2str(long ip, char *str) {

char *s=str;

 ulong2bcd(ip);
 process_ulong2str(str);
}
